var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CInput.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { mapToCssModules, tagPropType } from './Shared/helper.js'; //component - CoreUI / CInput

var commonPropTypes = process.env.NODE_ENV !== "production" ? {
  className: PropTypes.string,
  cssModule: PropTypes.object,
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  valid: PropTypes.bool,
  invalid: PropTypes.bool
} : {};

var CInput = function CInput(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      type = props.type,
      valid = props.valid,
      invalid = props.invalid,
      plaintext = props.plaintext,
      elementSize = props.elementSize,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "cssModule", "innerRef", "type", "valid", "invalid", "plaintext", "elementSize"]); // render


  var classes = mapToCssModules(classNames(plaintext ? 'form-control-plaintext' : 'form-control', elementSize && "form-control-" + elementSize, invalid && 'is-invalid', valid && 'is-valid', className), cssModule);
  return /*#__PURE__*/React.createElement("input", _extends({
    className: classes,
    type: type
  }, attributes, {
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 40,
      columnNumber: 10
    }
  }));
};

CInput.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, commonPropTypes, {
  plaintext: PropTypes.bool,
  type: PropTypes.string,
  elementSize: PropTypes.string
}) : {};
CInput.defaultProps = {
  type: 'text'
};

var CTextarea = function CTextarea(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      valid = props.valid,
      invalid = props.invalid,
      plaintext = props.plaintext,
      size = props.size,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "cssModule", "innerRef", "valid", "invalid", "plaintext", "size"]); // render


  var classes = mapToCssModules(classNames(plaintext ? 'form-control-plaintext' : 'form-control', size && "form-control-" + size, invalid && 'is-invalid', valid && 'is-valid', className), cssModule);
  return /*#__PURE__*/React.createElement("textarea", _extends({
    className: classes
  }, attributes, {
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 77,
      columnNumber: 10
    }
  }));
};

CTextarea.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, commonPropTypes, {
  plaintext: PropTypes.bool,
  size: PropTypes.string
}) : {};

var CInputFile = function CInputFile(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      valid = props.valid,
      invalid = props.invalid,
      custom = props.custom,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "cssModule", "innerRef", "valid", "invalid", "custom"]); // render


  var classes = mapToCssModules(classNames(custom ? 'custom-file-input' : 'form-control-file', invalid && 'is-invalid', valid && 'is-valid', className), cssModule);
  return /*#__PURE__*/React.createElement("input", _extends({
    className: classes
  }, attributes, {
    type: "file",
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 108,
      columnNumber: 10
    }
  }));
};

CInputFile.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, commonPropTypes, {
  custom: PropTypes.bool
}) : {};

var CInputCheckbox = function CInputCheckbox(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      valid = props.valid,
      invalid = props.invalid,
      custom = props.custom,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "cssModule", "innerRef", "valid", "invalid", "custom"]); // render


  var classes = mapToCssModules(classNames(custom ? 'custom-control-input' : 'form-check-input', invalid && 'is-invalid', valid && 'is-valid', className), cssModule);
  return /*#__PURE__*/React.createElement("input", _extends({
    className: classes,
    type: "checkbox"
  }, attributes, {
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 138,
      columnNumber: 10
    }
  }));
};

CInputCheckbox.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, commonPropTypes, {
  custom: PropTypes.bool
}) : {};

var CInputRadio = function CInputRadio(props) {
  return /*#__PURE__*/React.createElement(CInputCheckbox, _extends({}, props, {
    type: "radio",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 146,
      columnNumber: 30
    }
  }));
};

export { CInput, CTextarea, CInputFile, CInputCheckbox, CInputRadio };